<?php
/*
 * @Descripttion: 定制下发指令
 * @version: 1.0.0
 * @Author: likang
 * @Date: 2022-07-28 14:39:11
 * @LastEditors: likang
 * @LastEditTime: 2022-08-08 20:30:23
 */

namespace catchAdmin\api;

use catcher\Utils;
use think\facade\Db;

class Directive
{
    /**
     * @Descripttion: 下发指令
     * @name: likang
     * @param {*} $type 1 全部 2 部分
     * @param {*} $data  下发内容
     * @param {*} $order 指令类型
     * @param {*} $imei  数组 或者字符串
     * @return {*}
     */
    public static function Issued($type, $data, $order, $imei = '')
    {


        if ($type == 1) {
            $msetime = msectime();
            $cont = [
                'Type' => 'directive',
                'ContentType' => $order,
                'Content' => json_encode($data),
                'ContentId' => md5(time() . mt_rand(1, 1000000)),
                'AddTime' => $msetime,
                'Version' => $msetime,
                'Status' => 2
            ];
            Db::name('publish')->save($cont);
        } else {

            $imei =  is_array($imei) ? $imei : Utils::stringToArrayBy($imei);
            foreach ($imei as $item) {
                $msetime = msectime();
                $cont = [
                    'Type' => 'directive',
                    'ContentType' => $order,
                    'Content' => json_encode($data),
                    'ContentId' => md5(time() . mt_rand(1, 1000000)),
                    'AddTime' => $msetime,
                    'Version' => $msetime,
                    'Imei' => $item,
                    'Status' => 2
                ];
                Db::name('publish')->save($cont);
            }
        }
    }
}
