<?php

namespace catchAdmin\system\model;

use catchAdmin\hydraulic\model\HydEquipment;
use catchAdmin\hydraulic\model\Hydraulic;
use catchAdmin\permissions\model\DataRangScopeTrait;
use catcher\base\CatchModel as Model;
use think\facade\Db;

class Lssue extends Model
{
    use DataRangScopeTrait;
    // 表名
    public $name = 'lssue';
    // 数据库字段映射
    public $field = array(
        'id',
        // 内容
        'file_name',
        // 所有设备
        'equ_ids',
        // 指令类型
        'type',
        //指令类型
        'directive',
        //详情
        'info',
        // 创建人ID
        'creator_id',
        // 创建时间
        'created_at',
        // 更新时间
        'updated_at',
        // 软删除
        'deleted_at',
    );
    public function getList()
    {
        $res =  $this->dataRange()
            ->catchSearch()
            ->order($this->aliasField('id'), 'desc')
            ->paginate();
        return $res;
    }



    public function setEquIdsAttr($value)
    {
        $data = json_encode($value);
        return $data;
    }
    public function getEquIdsAttr()
    {
        $data =  $this->getData('equ_ids');
        $data = json_decode($data, true);
        $list =  HydEquipment::where('id', 'in', $data)->column('name');
        return implode(',', $list);
    }
    public function getDirectiveAttr()
    {
        $Directive =  $this->getData('directive');
        $sd = new SysDictData();
        return $sd->getValueByCode('directive', $Directive);
    }
    /**
     * @Descripttion: 下发指令
     * @name: likang
     * @return {*}
     */
    public function IssueAll($data)
    {
        $type = $data['type'];

        $content = [
            'file_name' => $data['file_name']
        ];


        if ($type == 1) {
            $msetime = msectime();
            $cont = [
                'Type' => 'directive',
                'ContentType' => 'File',
                'Content' => json_encode($content),
                'ContentId' => md5(time() . mt_rand(1, 1000000)),
                'AddTime' => $msetime,
                'Version' => $msetime,
                'Status' => 2
            ];
            Db::name('publish')->save($cont);
        }
        if ($type == 2) {
            $list = HydEquipment::alias('e')->leftJoin('hydraulic h', 'e.id = h.eq_id')
                ->where('e.id', 'in', $data['equ_ids'])->field('h.imei as imei')->select()->toArray();

            foreach ($list as $item) {

                if (!$item['imei']) {
                    continue;
                } else {
                    $msetime = msectime();
                    $cont = [
                        'Type' => 'directive',
                        'ContentType' => 'File',
                        'Content' => json_encode($content),
                        'ContentId' => md5(time() . mt_rand(1, 1000000)),
                        'AddTime' => $msetime,
                        'Version' => $msetime,
                        'Imei' => $item['imei'],
                        'Status' => 2
                    ];
                    Db::name('publish')->save($cont);
                }
            }
        }
    }
}
