<?php
/*
 * @Descripttion: 
 * @version: 1.0.0
 * @Author: likang
 * @Date: 2022-08-12 11:36:16
 * @LastEditors: likang
 * @LastEditTime: 2022-08-24 10:23:06
 */

namespace catchAdmin\tag_history\controller;

use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use catchAdmin\tag_history\model\Report as reportModel;

class Report extends CatchController
{
    protected $reportModel;

    public function __construct(ReportModel $reportModel)
    {
        $this->reportModel = $reportModel;
    }

    /**
     * 列表
     * @time 2022年08月12日 11:36
     * @param Request $request 
     */
    public function index(Request $request): \think\Response
    {
        return CatchResponse::paginate($this->reportModel->getList());
    }

    /**
     * 保存信息
     * @time 2022年08月12日 11:36
     * @param Request $request 
     */
    public function save(Request $request): \think\Response
    {
        return CatchResponse::success($this->reportModel->storeBy($request->post()));
    }

    /**
     * 读取
     * @time 2022年08月12日 11:36
     * @param $id 
     */
    public function read($id): \think\Response
    {
        return CatchResponse::success($this->reportModel->findBy($id));
    }

    /**
     * 更新
     * @time 2022年08月12日 11:36
     * @param Request $request 
     * @param $id
     */
    public function update(Request $request, $id): \think\Response
    {
        return CatchResponse::success($this->reportModel->updateBy($id, $request->post()));
    }

    /**
     * 删除
     * @time 2022年08月12日 11:36
     * @param $id
     */
    public function delete($id): \think\Response
    {
        return CatchResponse::success($this->reportModel->deleteBy($id));
    }
}
