<?php

namespace catchAdmin\tag_history\controller;

use catchAdmin\report\model\Report;
use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use catchAdmin\tag_history\model\TagHistory as tagHistoryModel;
use catcher\CatchAdmin;
use catcher\Code;
use think\facade\Db;

class TagHistory extends CatchController
{
    protected $tagHistoryModel;

    public function __construct(TagHistoryModel $tagHistoryModel)
    {
        $this->tagHistoryModel = $tagHistoryModel;
    }

    /**
     * 列表
     * @time 2022年08月12日 11:31
     * @param Request $request 
     */
    public function index(Request $request): \think\Response
    {

        $data = $request->get();
        $time =  isset($data['time']) ? $data['time'] : '';
        $mac = isset($data['mac']) ? $data['mac'] : '';
        $tage = isset($data['tage']) ? $data['tage'] : '';
        $endtime = isset($data['endtime']) ? $data['endtime'] : "";
        $meter = isset($data['meter']) ? $data['meter'] : "";
        $where = [];
        $create_id = $request->user()->id;
        //爬楼梯
        $manage = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 2)->find();
        $bool = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 3)->find();
        $shifouRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 4)->find();
        $ccccRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 5)->find();
        //
        $six = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 6)->find();
        //用于牛儿农户
        $nonghu = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 7)->find();
        //cs店
        $cs_store = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 8)->find();


        if (!empty($time)) {
            $onewhere[] = ['addTime', '>=', $time];
        } else {
            $onewhere[] = ['addTime', '>=', time()];
        }





        if (!empty($mac)) {
            $where[] = ['mac', 'in',  implode(",", $mac)];
        }
        if (!empty($tage)) {
            $where[] = ['lable', 'in',  implode(",", $tage)];
        }
        if ($endtime == 1) {
            //生成报告
            $end = time();
            if (empty($mac)) {
                $mac = $this->tagHistoryModel->group('mac')->column('mac');
            }
            if (empty($tage)) {
                $tage = $this->tagHistoryModel->group('lable')->column('lable');
            }
            $tagList =  $this->tagHistoryModel->where($where)->where('addTime', '<=', $end)->select();
            $content = [
                'mac' => json_encode($mac),
                'lable' => json_encode($tage),
                'meter' => $meter,
                'startTime' => $time,
                'endTime' => $end,
                'data' => json_encode($tagList)
            ];
            $report = new Report();
            $report->save($content);
            return CatchResponse::success('生成报告成功');
        }

        if ($bool) {
            $where[] = ['mac', 'in', '30B5F1013899'];
            $where[] = ['lable', 'in', "3543245626,3544976938,3544261098,1539178988,3544517098,3544959402,3542053498,3543226346,3544413306"];
        } elseif ($shifouRole) {
            $where[] = ['mac', 'in', '30B5F10138EB'];
            $where[] = ['lable', 'in', "30b5f6000006,30b5f6000007,30b5f6000008,0000f6000006,0000f6000007,0000f6000008,0000F6000003,0000F6000004,0000F6000005"];
        } elseif ($ccccRole) {
            $where[] = ['mac', 'in', '30B5F10138ED,30B5F1012F7A'];
            $where[] = ['lable', 'in', "000000880002,000000880003,000000880004"];
        } elseif ($nonghu) {
            $where[] = ['mac', 'in', '30B5F10138ED'];
            $where[] = ['lable', 'in', "000000880002,000000880003"];
        } elseif ($six) {

            $where[] = ['mac', 'in', '30B5F1013801'];
            $where[] = ['lable', 'in', "0000e2b7a905,0000e2b7a2c5,0000ea511abe,0000e2b6d355"];
        } else if ($manage) {
            $where[] = ['mac', 'in', '30B5F10138BA'];
            $where[] = ['lable', 'in', "87011111CFC1,8702222CFC1,8702222CFC1"];
        } else if ($cs_store) {
            $where[] = ['mac', 'in', '30B5F1013238,30B5F10138EB'];
            $where[] = ['lable', 'in', "000080000001,000080000002,0000F6000003,0000F6000004,0000F6000005"];
        }

        $list = $this->tagHistoryModel->group('mac,lable')->where('addTime','>',strtotime(date('Y-d-m')))->where($where)
            ->field('mac,lable')->select()->toArray();
       
        foreach ($list as $key => $value) {
            $towwhere=
            [
                ['mac', '=', $value['mac']],
                ['lable', '=', $value['lable']]
            ];

            $value['addTime'] = $this->tagHistoryModel->where($onewhere)->
               where($towwhere)->max('addTime');
            var_dump($value['addTime']);
            $list[$key]['addTime'] = $value['addTime'];
            $value['ave_rssi']= $this->tagHistoryModel->where($towwhere)->where($onewhere)->avg('rssi');
            $list[$key]['ave_rssi'] =  $value['ave_rssi'];
            $value['num']=$this->tagHistoryModel->where($onewhere)->where($towwhere)->count();
            $list[$key]['num'] = $value['num'];
            $wheres = [];
            $wh = [];
            $da = null;
            $wheres[] = ['mac', '=', $value['mac']];
            $wheres[] = ['lable', '=', $value['lable']];
            $wheres[] = ['addTime', '=', $value['addTime']];
            $da = $this->tagHistoryModel->where($wheres)->find(); 
            
            $wh =[
                ['mac', '=', $value['mac']],
                ['lable', '=', $value['lable']],
                ['addTime', '<', $value['addTime']]
             ];
           
            $list[$key]['status']=1;
            //1 在线 0 离线
            if($shifouRole)
            {
                $time = $this->tagHistoryModel->where($wh)->max('addTime');
               
                if(($value['addTime']-$time)<=90)
                {
                    $list[$key]['status']=1;
                }
                else
                {
                    $list[$key]['status']=0;
                }
            }
            $list[$key]['rssi'] = $da['rssi'];
            $list[$key]['move'] = $da['move'];
            $list[$key]['step'] = $da['step'];
            $list[$key]['temperature'] = $da['temperature'];
            $list[$key]['addTime'] = date('Y-m-d H:i:s', $value['addTime']);
            $list[$key]['time'] = date('Y-m-d H:i:s', $da['time']);

            if ($da['temperWarn'] == '00') {
                $list[$key]['temperWarn'] = '正常';
            } elseif ($da['temperWarn'] == '01') {
                $list[$key]['temperWarn'] = '低温告警';
            } elseif ($da['temperWarn'] == '10') {
                $list[$key]['temperWarn'] = '高温告警';
            }
        }
        return CatchResponse::success($list);
    }

    /**
     * 保存信息
     * @time 2022年08月12日 11:31
     * @param Request $request 
     */
    public function save(Request $request): \think\Response
    {
        return CatchResponse::success($this->tagHistoryModel->storeBy($request->post()));
    }

    /**
     * 读取
     * @time 2022年08月12日 11:31
     * @param $id 
     */
    public function read($id): \think\Response
    {
        return CatchResponse::success($this->tagHistoryModel->findBy($id));
    }

    /**
     * 更新
     * @time 2022年08月12日 11:31
     * @param Request $request 
     * @param $id
     */
    public function update(Request $request, $id): \think\Response
    {
        return CatchResponse::success($this->tagHistoryModel->updateBy($id, $request->post()));
    }
    /**
     * 删除
     * @time 2022年08月12日 11:31
     * @param $id
     */
    public function delete($id): \think\Response
    {
        return CatchResponse::success($this->tagHistoryModel->deleteBy($id));
    }

    /**
     * @Descripttion: 获取设备
     * @name: likang
     * @return {*}
     */
    public function getStations(Request $request)
    {
        $create_id = $request->user()->id;
        $where = [];
        //爬楼梯
        $manage = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 2)->find();
        $bool = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 3)->find();
        $shifouRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 4)->find();
        //牛儿管理
        $ccccRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 5)->find();
        //
        $six = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 6)->find();
        //用于牛儿农户
        $nonghu = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 7)->find();
        //cs店
        $cs_store = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 8)->find();
        $mac = null;
        if ($bool) {
            $mac = '30B5F1013899';
        } else if ($shifouRole) {
            $mac = '30B5F10138EB';
        } elseif ($ccccRole) {
            $mac = '30B5F10138ED,30B5F1012F7A';
        } elseif ($nonghu) {
            $mac = '30B5F10138ED';
        } elseif ($six) {
            $mac = '30B5F1013801';
        } elseif ($manage) {
            $mac = '30B5F10138BA';
        } elseif ($cs_store) {
            $mac = '30B5F1013238,30B5F10138EB';
        }
        $list = explode(',', $mac);
        return CatchResponse::success($list);
    }
    /**
     * @Descripttion: 获取标签
     * @name: likang
     * @return {*}
     */
    public function getTages(Request $request)
    {
        $create_id = $request->user()->id;
        $where = [];
        //爬楼梯
        $manage = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 2)->find();
        $bool = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 3)->find();
        $shifouRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 4)->find();
        //牛儿管理
        $ccccRole = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 5)->find();
        //
        $six = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 6)->find();
        //用于牛儿农户
        $nonghu = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 7)->find();
        //测试cs店
        $cs_store = Db::name('user_has_roles')->where('uid', $create_id)->where('role_id', 8)->find();
        $lable = null;

        if ($bool) {
            $lable =  "3543245626,3544976938,3544261098,1539178988,3544517098,3544959402,3542053498,3543226346,3544413306";
        } elseif ($shifouRole) {
            $lable = "30b5f6000006,30b5f6000007,30b5f6000008,0000f6000006,0000f6000007,0000f6000008,0000F6000003,0000F6000004,0000F6000005";
        } elseif ($ccccRole) {
            $lable =  "000000880002,000000880003,000000880004";
        } elseif ($nonghu) {
            $lable =  "000000880002,000000880003";
        } elseif ($six) {
            $lable = "0000e2b7a905,0000e2b7a2c5,0000ea511abe,0000e2b6d355";
        } else if ($manage) {
            $lable = "87011111CFC1,8702222CFC1,8702222CFC1";
        } else if ($cs_store) {
            $lable = "000080000001,000080000002,0000F6000003,0000F6000004,0000F6000005";
        }
        $list = explode(',', $lable);

        return CatchResponse::success($list);
    }
    /**
     * @Descripttion: 获取时间
     * @name: likang
     * @return {*}
     */
    public function getTime()
    {

        $time = time();
        return CatchResponse::success($time);
    }
    /**
     * @Descripttion: 根据标签和设备获取数据和心跳
     * @name: likang
     * @param {Request} $request
     * @return {*}
     */
    public function getRecordByTag(Request $request)
    {
        $lable = $request->get('lable');
        $mac = $request->get('mac');
        $limit = 10;
        $page = 1;
        if ($request->get('page')) {
            $page = $request->get('page');
        }
        if ($request->get('limit')) {
            $limit = $request->get('limit');
        }
        $where = [
            ['lable', '=', $lable],
            ['mac', '=', $mac]
        ];
        $list = $this->tagHistoryModel->where($where)->order('addTime desc')->page($page)->limit($limit)->select();
        foreach ($list as $key => $value) {
            $list[$key]['time'] = date('Y-m-d H:i:s', $value['time']);
            $list[$key]['addTime'] = date('Y-m-d H:i:s', $value['addTime']);
            if ($value['temperWarn'] == '00') {
                $list[$key]['temperWarn'] = '正常';
            } elseif ($value['temperWarn'] == '01') {
                $list[$key]['temperWarn'] = '低温告警';
            } elseif ($value['temperWarn'] == '10') {
                $list[$key]['temperWarn'] = '高温告警';
            }
        }
        return json([
            'code'    => Code::SUCCESS,
            'message' => 'success',
            'count'   => $this->tagHistoryModel->where($where)->count(),
            'current' => $page,
            'limit'   => $limit,
            'data'    => $list,
        ]);
    }

    /**
     * 折现图
     */
    public function lineChart(Request $request)
    {
        $data = $request->get();
        $mac = null;
        $lable = null;
        if (!empty($data['start_time'])) {
            $start_time = strtotime($data['start_time'][0]);
            $end_time = strtotime($data['start_time'][1]);
        }

        if (empty($start_time)) {
            $start_time = strtotime(date('Y-m-d'));
        }
        if (!empty($data['mac'])) {
            $mac = $data['mac'];
        }
        if (!empty($data['lable'])) {
            $lable = $data['lable'];
        }
        $end_time = null;
        if (!$end_time) {
            $end_time = time();
        }

        $where = [];
        $where[] = ['addTime', '>=', $start_time];
        $where[] = ['addTime', '<', $end_time];
        $where[] = ['mac', '=', $mac];
        $where[] = ['lable', '=', $lable];

        $list = $this->tagHistoryModel->where($where)->order('addTime asc')->select();


        $time = [];
        $lable1 = [];

        foreach ($list as $item) {
            $time[] = date('Y-m-d H:i:s', $item['addTime']);
            $lable1[] = $item['temperature'];
        }
        $renData = [];
        $renData = [
            'xAxis' => $time,
            'legend' => [$lable],
            'series' => [
                [
                    'name' => $lable,
                    'type' => 'line',
                    'stack' => 'Total',
                    'data' => $lable1
                ],

            ]

        ];
        return CatchResponse::success($renData);
    }
}
